Package ru.bitel.bgbilling.modules.bill.common.service

# Interface BillService

All Superinterfaces:
  `LoggableService`

@MTOM public interface BillService extends LoggableService

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `attributeDelete(int contractId, int attributeId)`
  Удаление реквизита договора.
  `List<Attribute>`
  `attributeList(int contractId)`
  Получить список реквизитов договора.
  `void`
  `attributeTypeDelete(int attributeTypeId)`
  Удаление типа реквизита.
  `List<AttributeType>`
  `attributeTypeList()`
  Получение типов реквизитов.
  `void`
  `attributeTypeUpdate(AttributeType attributeType)`
  Обновление(id>0)/создание(idinvalid input: '<'=0) типа реквизита договора.
  `void`
  `attributeUpdate(int contractId, Attribute attribute)`
  Обновление(id>0)/создание(idinvalid input: '<'=0) реквизита договора.
  `void`
  `bankAccountCopy(int fromContractId, int toContractId)`
  `BankAccount`
  `bankAccountDefaultGet(int organizationId)`
  `void`
  `bankAccountDefaultSet(BankAccount bankAccount)`
  `void`
  `bankAccountDelete(int bankAccountId)`
  `BankAccount`
  `bankAccountGet(int bankAccountId)`
  `List<BankAccount>`
  `bankAccountList(int organizationId, Boolean inUse)`
  Список банковских счетов, которые могут быть указаны в счете.
  `void`
  `bankAccountSet(int contractId, int bankAccountId)`
  Банковский Счет для договора по умолчанию
  `List<IdTitle>`
  `bankAccountTitleList(int contractId, int organizationId, Boolean inUse, jakarta.xml.ws.Holder<Integer> selectedItemId)`
  Список доступных банковских счетов из справочника банков
  `void`
  `bankAccountUpdate(BankAccount bankAccount)`
  `BillAccountsReceivableDetail`
  `billAccountsReceivableDetail(int contractId, LocalDate onDate)`
  `void`
  `billDelete(List<Integer> billIds)`
  `int`
  `billDocumentCreate(int contractId, int documentSpecId, int bankAccountId, int year, int month, List<DocumentPosition> documentPositionList)`
  Создание счета
  `void`
  `billDocumentDelete(int contractId, int id, boolean customer)`
  Удаление счета.
  `ru.bitel.bgbilling.common.dto.FileDto`
  `billDocumentDownload(int contractId, int id)`
  Получение счета в формате PDF.
  `Result<BillDocument>`
  `billDocumentListForContract(int contractId, Page page)`
  Получение списка счетов для договора
  `List<BillLink>`
  `billLinkList()`
  `void`
  `billLinkUpdate(BillLink billLink)`
  `List<IdTitle>`
  `contractParameters()`
  `void`
  `docTypeDelete(int id)`
  `DocType`
  `docTypeGet(int id)`
  `List<DocType>`
  `docTypeList(DocumentType documentType)`
  `List<DocType>`
  `docTypeListForContract(int contractId, DocumentType documentType)`
  `List<IdTitle>`
  `docTypeTitles(int contractId, DocumentType documentType)`
  `void`
  `docTypeUpdate(DocType dt)`
  `List<DocType>`
  `documentSpecListForCustomer(int contractId)`
  Список разрешенных типов документов для договора, которые клиент/абонент может создать.
  `DocTypes`
  `documentTypes(int contractId, DocumentType documentType)`
  `String`
  `exportDocs(String exportClass, BillListFilter billListFilter, boolean saveOnServer)`
  `List<ru.bitel.bgbilling.common.model.KeyValue>`
  `exportFormats(String docType)`
  `ru.bitel.bgbilling.modules.bill.common.export.BillExportInfo`
  `exportInfo(String exportKey)`
  `void`
  `invoiceDelete(List<Integer> invoiceIds)`
  `ru.bitel.bgbilling.common.dto.FileDto`
  `invoiceDocumentDownload(int contractId, int id)`
  Получение счёт-фактуры в формате PDF.
  `Result<InvoiceDocument>`
  `invoiceDocumentListForContract(int contractId, boolean onlyReady, Page page)`
  Получение списка счёт-фактур
  `void`
  `numerationPoolDelete(int id)`
  `NumerationPool`
  `numerationPoolGet(int id)`
  `List<NumerationPool>`
  `numerationPoolList()`
  `void`
  `numerationPoolUpdate(NumerationPool numerationPool)`
  `void`
  `organizationCopy(int fromContractId, int toContractId)`
  `Organization`
  `organizationDefaultGet()`
  `void`
  `organizationDefaultSet(int organizationId)`
  `void`
  `organizationDelete(int organizationId)`
  `Organization`
  `organizationGet(int organizationId)`
  `List<Organization>`
  `organizationList()`
  `void`
  `organizationSet(int contractId, int organizationId)`
  `List<IdTitle>`
  `organizationTitleList(int contractId, Boolean inUse, jakarta.xml.ws.Holder<Integer> selectedId)`
  `void`
  `organizationUpdate(Organization organization)`
  `void`
  `positionDataDelete(BillPositionType billPositionType, String key)`
  `void`
  `positionDataUpdate(BillPositionType billPositionType, String positionData)`
  `boolean`
  `positionDelete(DocumentType documentType, int positionId)`
  `Position`
  `positionGet(DocumentType documentType, int positionId)`
  `List<IdTitle>`
  `positionList(DocumentType documentType)`
  `List<String>`
  `positionSearch(BillPositionType billPositionType, Page page)`
  `Position`
  `positionUpdate(DocumentType documentType, Position position)`
  `BigDecimal`
  `rateVATGet()`
  `SearchResult<Position>`
  `searchPositionList(DocumentType documentType, Page page)`
  `void`
  `sendDocs(DocumentSendParameters senderTaskParameters)`
  Рассылает указанные документы по соответствующим договорам.
  `void`
  `sendDocsForAll(DocumentSendParameters senderTaskParameters)`
  Рассылает документы с компоновкой.
  `List<DocumentPosition>`
  `templateDocumentPositionList(int contractId, int documentSpecId, int year, int month)`
  Список шаблонов-позиций документа для создания счета клиентом/абонентом.
  `MapHolder<Integer,List<IdTitle>>`
  `xmlComposition()`
  Получить структуру возможной XML-ки.
  На данный момент она содержит все модули и плагины.

  ### Methods inherited from interface ru.bitel.common.model.LoggableService

  `logList`

- ## Method Details

  - ### attributeDelete

    void attributeDelete(int contractId, int attributeId) throws ru.bitel.bgbilling.common.BGException
    Удаление реквизита договора.
    Parameters:
      `contractId` - - код договора.
      `attributeId` - - код реквизита.
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### attributeList

    List<Attribute> attributeList(int contractId) throws ru.bitel.bgbilling.common.BGException
    Получить список реквизитов договора.
    Parameters:
      `contractId` - - код договора.
    Returns:
      - список
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### attributeTypeDelete

    void attributeTypeDelete(int attributeTypeId) throws ru.bitel.bgbilling.common.BGException
    Удаление типа реквизита.
    Parameters:
      `attributeTypeId` - - код типа реквизита.
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### attributeTypeList

    List<AttributeType> attributeTypeList() throws ru.bitel.bgbilling.common.BGException
    Получение типов реквизитов.
    Returns:
      - список типов реквизитов.
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### attributeTypeUpdate

    void attributeTypeUpdate(AttributeType attributeType) throws ru.bitel.bgbilling.common.BGException
    Обновление(id>0)/создание(idinvalid input: '<'=0) типа реквизита договора.
    Parameters:
      `attributeType` - - тип реквизита.
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### attributeUpdate

    void attributeUpdate(int contractId, Attribute attribute) throws ru.bitel.bgbilling.common.BGException
    Обновление(id>0)/создание(idinvalid input: '<'=0) реквизита договора.
    Parameters:
      `contractId` - - код договора.
      `attribute` - - реквизит.
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### bankAccountCopy

    void bankAccountCopy(int fromContractId, int toContractId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### bankAccountDefaultGet

    BankAccount bankAccountDefaultGet(int organizationId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### bankAccountDefaultSet

    void bankAccountDefaultSet(BankAccount bankAccount) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### bankAccountDelete

    void bankAccountDelete(int bankAccountId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### bankAccountGet

    BankAccount bankAccountGet(int bankAccountId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### bankAccountList

    List<BankAccount> bankAccountList(int organizationId, Boolean inUse) throws ru.bitel.bgbilling.common.BGException
    Список банковских счетов, которые могут быть указаны в счете.
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### bankAccountSet

    void bankAccountSet(int contractId, int bankAccountId) throws ru.bitel.bgbilling.common.BGException
    Банковский Счет для договора по умолчанию
    Parameters:
      `contractId` -
      `selectedBabkAccountId` -
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### bankAccountTitleList

    List<IdTitle> bankAccountTitleList(int contractId, int organizationId, Boolean inUse, jakarta.xml.ws.Holder<Integer> selectedItemId) throws ru.bitel.bgbilling.common.BGException
    Список доступных банковских счетов из справочника банков
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### bankAccountUpdate

    void bankAccountUpdate(BankAccount bankAccount) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### billAccountsReceivableDetail

    BillAccountsReceivableDetail billAccountsReceivableDetail(int contractId, LocalDate onDate) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### billDelete

    void billDelete(List<Integer> billIds) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### billDocumentCreate

    int billDocumentCreate(int contractId, int documentSpecId, int bankAccountId, int year, int month, List<DocumentPosition> documentPositionList) throws ru.bitel.bgbilling.common.BGException
    Создание счета
    Parameters:
      `contractId` - ID договора
      `documentSpecId` - ID типа документа
      `bankAccountId` - ID банковского счета, который будет указан в счете
      `year` - год
      `month` - месяц (0 - январь)
      `documentPositionList` -
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### billDocumentDelete

    void billDocumentDelete(int contractId, int id, boolean customer) throws ru.bitel.bgbilling.common.BGException
    Удаление счета. Если customer=true, то удаление возможно только в том случае, если счет был создан клиентом (uid=-1) и счет не оплачен (status=0).
    Parameters:
      `contractId` - ID договора
      `id` - ID счета
      `customer` - удаление клиентом/абонентом
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### billDocumentDownload

    ru.bitel.bgbilling.common.dto.FileDto billDocumentDownload(int contractId, int id) throws ru.bitel.bgbilling.common.BGException
    Получение счета в формате PDF.
    Parameters:
      `contractId` - ID договора
      `id` - ID счета
      `name` - результат - имя файла
      `data` - результат - файл
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### billDocumentListForContract

    Result<BillDocument> billDocumentListForContract(int contractId, Page page) throws ru.bitel.bgbilling.common.BGException
    Получение списка счетов для договора
    Parameters:
      `contractId` - ID договора
      `page` - страница
    Returns:
      объект result = { list + page }
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### billLinkList

    List<BillLink> billLinkList() throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### billLinkUpdate

    void billLinkUpdate(BillLink billLink) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractParameters

    List<IdTitle> contractParameters() throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### docTypeDelete

    void docTypeDelete(int id) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### docTypeGet

    DocType docTypeGet(int id) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### docTypeList

    List<DocType> docTypeList(DocumentType documentType) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### docTypeListForContract

    List<DocType> docTypeListForContract(int contractId, DocumentType documentType) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### docTypeTitles

    List<IdTitle> docTypeTitles(int contractId, DocumentType documentType) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### docTypeUpdate

    void docTypeUpdate(DocType dt) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### documentSpecListForCustomer

    List<DocType> documentSpecListForCustomer(int contractId) throws ru.bitel.bgbilling.common.BGException
    Список разрешенных типов документов для договора, которые клиент/абонент может создать. Типы документов должны быть добавлены в договор, а в конфиге модуля указан дополнительный фильтр allowed.web.bill.types
    Parameters:
      `contractId` - ID договора
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### documentTypes

    DocTypes documentTypes(int contractId, DocumentType documentType) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### exportDocs

    String exportDocs(String exportClass, BillListFilter billListFilter, boolean saveOnServer) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### exportFormats

    List<ru.bitel.bgbilling.common.model.KeyValue> exportFormats(String docType) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### exportInfo

    ru.bitel.bgbilling.modules.bill.common.export.BillExportInfo exportInfo(String exportKey) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### invoiceDelete

    void invoiceDelete(List<Integer> invoiceIds) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### invoiceDocumentDownload

    ru.bitel.bgbilling.common.dto.FileDto invoiceDocumentDownload(int contractId, int id) throws ru.bitel.bgbilling.common.BGException
    Получение счёт-фактуры в формате PDF.
    Parameters:
      `contractId` - ID договора
      `id` - ID счёт-фактуры
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### invoiceDocumentListForContract

    Result<InvoiceDocument> invoiceDocumentListForContract(int contractId, boolean onlyReady, Page page) throws ru.bitel.bgbilling.common.BGException
    Получение списка счёт-фактур
    Parameters:
      `contractId` - ID договора
      `onlyReady` - только готовые
      `page` - страница
    Returns:
      объект result = { list + page }
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### numerationPoolDelete

    void numerationPoolDelete(int id) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### numerationPoolGet

    NumerationPool numerationPoolGet(int id) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### numerationPoolList

    List<NumerationPool> numerationPoolList() throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### numerationPoolUpdate

    void numerationPoolUpdate(NumerationPool numerationPool) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### organizationCopy

    void organizationCopy(int fromContractId, int toContractId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### organizationDefaultGet

    Organization organizationDefaultGet() throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### organizationDefaultSet

    void organizationDefaultSet(int organizationId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### organizationDelete

    void organizationDelete(int organizationId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### organizationGet

    Organization organizationGet(int organizationId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### organizationList

    List<Organization> organizationList() throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### organizationSet

    void organizationSet(int contractId, int organizationId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### organizationTitleList

    List<IdTitle> organizationTitleList(int contractId, Boolean inUse, jakarta.xml.ws.Holder<Integer> selectedId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### organizationUpdate

    void organizationUpdate(Organization organization) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### positionDataDelete

    void positionDataDelete(BillPositionType billPositionType, String key) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### positionDataUpdate

    void positionDataUpdate(BillPositionType billPositionType, String positionData) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### positionDelete

    boolean positionDelete(DocumentType documentType, int positionId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### positionGet

    Position positionGet(DocumentType documentType, int positionId) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### positionList

    List<IdTitle> positionList(DocumentType documentType) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### positionSearch

    List<String> positionSearch(BillPositionType billPositionType, Page page) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### positionUpdate

    Position positionUpdate(DocumentType documentType, Position position) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### rateVATGet

    BigDecimal rateVATGet() throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### searchPositionList

    SearchResult<Position> searchPositionList(DocumentType documentType, Page page) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### sendDocs

    void sendDocs(DocumentSendParameters senderTaskParameters) throws ru.bitel.bgbilling.common.BGException
    Рассылает указанные документы по соответствующим договорам. Вызывается из меню "отослать на почту"
    Parameters:
      `senderTaskParameters` - параметры для рассылки
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### sendDocsForAll

    void sendDocsForAll(DocumentSendParameters senderTaskParameters) throws ru.bitel.bgbilling.common.BGException
    Рассылает документы с компоновкой. Вызывается из просмотра документа - "разослать на почту"
    Parameters:
      `senderTaskParameters` - параметры для рассылки
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### templateDocumentPositionList

    List<DocumentPosition> templateDocumentPositionList(int contractId, int documentSpecId, int year, int month) throws ru.bitel.bgbilling.common.BGException
    Список шаблонов-позиций документа для создания счета клиентом/абонентом.
    Parameters:
      `contractId` - ID договора
      `documentSpecId` - ID типа документа
      `year` - год
      `month` - месяц (0 - январь)
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### xmlComposition

    MapHolder<Integer,List<IdTitle>> xmlComposition() throws ru.bitel.bgbilling.common.BGException
    Получить структуру возможной XML-ки.
    На данный момент она содержит все модули и плагины. А для договора заполняется в клиенте.
    Returns:
      - map, в котором под кодом 1 - модули, 2 - плагины.
    Throws:
      `ru.bitel.bgbilling.common.BGException`